//
//  ListOneColumnFullWidthTextBodyTextModel.swift
//  MVMCoreUI
//
//  Created by Kruthika KP on 05/03/20.
//  Copyright © 2020 Verizon Wireless. All rights reserved.
//

import Foundation


public class ListOneColumnFullWidthTextBodyTextModel: ListItemModel, MoleculeModelProtocol {
    //--------------------------------------------------
    // MARK: - Properties
    //--------------------------------------------------
    
    public static var identifier: String = "list1CFWBdy"
    public var headlineBody: HeadlineBodyModel
    
    //--------------------------------------------------
    // MARK: - Initializier
    //--------------------------------------------------
    
    public init(headlineBody: HeadlineBodyModel) {
        self.headlineBody = headlineBody
        super.init()
    }
    
    //--------------------------------------------------
    // MARK: - Methods
    //--------------------------------------------------
    
    override public func setDefaults() {
        super.setDefaults()
        headlineBody.style = .item
    }
    
    //--------------------------------------------------
    // MARK: - Keys
    //--------------------------------------------------
    
    private enum CodingKeys: String, CodingKey {
        case moleculeName
        case headlineBody
    }
    
    //--------------------------------------------------
    // MARK: - Codec
    //--------------------------------------------------
    
    required public init(from decoder: Decoder) throws {
        let typeContainer = try decoder.container(keyedBy: CodingKeys.self)
        headlineBody = try typeContainer.decode(HeadlineBodyModel.self, forKey: .headlineBody)
        try super.init(from: decoder)
    }
    
    public override func encode(to encoder: Encoder) throws {
        try super.encode(to: encoder)
        var container = encoder.container(keyedBy: CodingKeys.self)
        try container.encode(moleculeName, forKey: .moleculeName)
        try container.encode(headlineBody, forKey: .headlineBody)
    }
}
